<?php
/*
Maildir Clean Up .:. Version: 1.4 Released On 4 Mar 2014

Created by Jeremy O'Connell
Interworx Forum Handle: cleverwise

NO WARRANTY is expressed or implied.  You are free to use this script for commercial and noncommercial usage.
*/

//	Setup defaults
$home_root='/var';
$trash_days='7';
$junk_days='14';

//	Load mail variables
if (isset($argv[1])) {
	$clivars=explode(',',$argv[1]);

	$cleanupvars=array();
	foreach ($clivars as $clivar) {
		if ($clivar and substr_count($clivar,':') == '1') {
			list($clivar_key,$clivar_value)=explode(':',$clivar);
			$cleanupvars[$clivar_key]=$clivar_value;
		}

		//	Run path check
		if (isset($cleanupvars['pathcheck'])) {
			if (is_dir('/var/vpopmail')) {
				print 'Your mail path is the default, so you may skip/omit the path setting';
			} elseif (is_dir('/chroot/home/vpopmail')) {
				print 'You should set path:/chroot/home';
			} elseif (is_dir('/home/vpopmail')) {
				print 'You should set path:/home';
			} else {
				print 'Sorry unable to determine your path, so try the following shell command> find / -name vpopmail';
			}

			print "\n";
			die();
		}

		//	If trash is set and value set value
		if (isset($cleanupvars['trash'])) {
			if (is_numeric($cleanupvars['trash']) or $cleanupvars['trash'] == 'skip') {
				$trash_days=$cleanupvars['trash'];
			}
		}

		//	If junk is set and value set value
		if (isset($cleanupvars['junk'])) {
			if (is_numeric($cleanupvars['junk']) or $cleanupvars['junk'] == 'skip') {
				$junk_days=$cleanupvars['junk'];
			}
		}

		//	If path is set and value set value
		if (isset($cleanupvars['path'])) {
			$home_root=$cleanupvars['path'];
		}
	}
}

//	If path doesn't exist then exit
if (!is_dir($home_root)) {
	print 'Invalid path'."\n";
	die();
}

//	Load domains
$domains=array();
if ($handle = opendir("$home_root/vpopmail/domains/")) {
	while (false !== ($entry = readdir($handle))) {
		if ($entry != "." && $entry != "..") {
			array_push($domains,$entry);
		}
	}
}

//	Loop through the domains and clean each mailbox
foreach ($domains as $domain) {

	//	Load domain email address
	$emailaccounts=array();
	if ($handle = opendir("$home_root/vpopmail/domains/$domain")) {
		while (false !== ($entry = readdir($handle))) {
			if ($entry != "." && $entry != ".." && $entry != ".qmail-default" && $entry != ".bounceon" && $entry != ".filterrules") {
				array_push($emailaccounts,$entry);
			}
		}	
	}

	//	Clean each user
	foreach ($emailaccounts as $emailaccount) {
		if ($trash_days != 'skip') {
			$folder='.Trash';
			clean_mail($home_root,$domain,$emailaccount,$folder,$trash_days);
		}
		if ($junk_days != 'skip') {
			$folder='.Spam';
			clean_mail($home_root,$domain,$emailaccount,$folder,$junk_days);
		}
	}

}

/////////////////////////////////////////////////////////////////////
//////	Clean mail
/////////////////////////////////////////////////////////////////////
function clean_mail($home_root,$domain,$emailaccount,$folder,$days) {
	//	Build mail directory
	$directory=$home_root.'/vpopmail/domains/'.$domain.'/'.$emailaccount.'/Maildir/'.$folder;

	//	Build and check current directory
	$directory_cur=$directory.'/cur';
	if (file_exists($directory_cur)) {
		//	Get mail ids and load them into array
		exec("find $directory_cur* -mtime +$days",$mailids);

		//	If mail ids have been returned process them
		if ($mailids) {
			foreach ($mailids as $mailid) {
				//	If mail id is NOT directory and exists delete
				if (!is_dir($mailid) and file_exists($mailid)) {
					unlink($mailid);
				}
			}
		}
	}

	//	Build and check new directory
	$directory_new=$directory.'/new';
	if (file_exists($directory_new)) {
		exec("find $directory_new* -mtime +$days",$mailids);

		//	If mail ids have been returned process them
		if ($mailids) {
			foreach ($mailids as $mailid) {
				//	If mail id is NOT directory and exists delete
				if (!is_dir($mailid) and file_exists($mailid)) {
					unlink($mailid);
				}
			}
		}
	}

}